// extends gibt an, von welcher Klasse man erben moechte
// Damit erbt man auch alle Eigenschaften der 
// uebergeordneten Klassen, bis hin zu Object
public class MyFiniteStackException extends Exception {

    int numElem;
    
    static final long serialVersionUID = 123;

    // mit super() ruft man den Konstruktor der
    // Oberklasse auf
    public MyFiniteStackException() { super(); numElem = 0;}
    
    public MyFiniteStackException(int numberOfMyStackElements) {
	super("*** MyFiniteStackException\n"); 
	numElem = numberOfMyStackElements;
    }

    // REDEFINITION: Eine in einer uebergeordneten Klasse
    // bereits eingefuehrte Methode wird hier mit
    // der gleichen Signatur neu eingefuehrt.
    // Ist obj vom Typ MyFiniteStackException, wird
    // bei obj.getMessage() genau die redefinierte Methode
    // verwendet.
    public String getMessage() {

        return "+++ MyFiniteStackException: "
               + "current stacksize is "
               + String.valueOf(numElem);

    }
   
}
